#pragma once

#include "Interval.h"

class CIntervalInitInfoImpl: public Eyw::CDatatypeInitInfoImpl<IIntervalInitInfo>
{
public:
	CIntervalInitInfoImpl( const Eyw::OBJECT_CREATIONCTX* pCtx );

// ITrackerStateInitInfo
public:
    virtual EYWAPI ~CIntervalInitInfoImpl();

};

////////////////////////////////////////////////////////////////////////////////////
class CIntervalImpl : public Eyw::CDatatypeImpl<IInterval>
{
public:
	CIntervalImpl( const Eyw::OBJECT_CREATIONCTX* pCtx );
	
	static Eyw::IObject* CreateInstance( const Eyw::OBJECT_CREATIONCTX* pCtx );

// ISerialize
	virtual Eyw::PMEM_BUF EYWAPI Serialize() const;
	virtual void EYWAPI ReleaseBuffer( Eyw::PMEM_BUF pBuf ) const;
	virtual bool EYWAPI Unserialize( Eyw::PCMEM_BUF pBuf );

	virtual Eyw::STR EYWAPI SerializeAsText() const;
	virtual bool EYWAPI UnserializeFromText(Eyw::CSTR str);
	virtual void EYWAPI ReleaseText( Eyw::STR str ) const;

	virtual void EYWAPI CopyFrom( const ISerialize* pSourceDatatype );

// IInterval
	virtual void SetMin( double val );
	virtual void SetMax( double max );
	virtual double GetMin() const;
	virtual double GetMax() const;

public:
	virtual EYWAPI ~CIntervalImpl();

private:
	// Here place the data members of the datatype
	double _min;
	double _max;
};
