#pragma once

class CLabelledSetIntervalGenerator : public Eyw::CBlockImpl
{
public:
	CLabelledSetIntervalGenerator( const Eyw::OBJECT_CREATIONCTX* ctxPtr );
	~CLabelledSetIntervalGenerator();

protected:
	virtual void InitSignature();	// should also initialize layout and private data
	virtual void CheckSignature();
	virtual void DoneSignature();

	// Actions
	virtual bool Init() throw();
	virtual bool Start() throw();
	virtual bool Execute() throw();
	virtual void Stop() throw();
	virtual void Done() throw();

	virtual void OnChangedParameter( const std::string& parameterId );
	void CheckVariableParameters();

private:
	struct item
	{
		Eyw::string_ptr _pLabel;
		Eyw::double_ptr _pMin;
		Eyw::double_ptr _pMax;
	};
	Eyw::labelled_set_ptr _pOutOutput;
	Eyw::int_ptr _pParNumItems;
	std::vector<item> _params;

};
