#pragma once

class CVector : public Eyw::CBlockImpl
{
public:
	CVector( const Eyw::OBJECT_CREATIONCTX* ctxPtr );
	~CVector();

protected:
	virtual void InitSignature();	// should also initialize layout and private data
	virtual void CheckSignature();
	virtual void DoneSignature();

	// Actions
	virtual bool Init() throw();
	virtual bool Start() throw();
	virtual bool Execute() throw();
	virtual void Stop() throw();
	virtual void Done() throw();

	virtual void OnChangedParameter( const std::string& parameterId );
	void ResetInternalArray();

private:
	Eyw::int_ptr _pParamSize;
	Eyw::trigger_ptr _pParamReset;
	Eyw::bool_ptr _pParamEnable_read;
	Eyw::int_ptr _pParamRead_position;
	Eyw::bool_ptr _pParamEnable_write;
	Eyw::int_ptr _pParamWrite_position;
	Eyw::datatype_ptr _pInInput;
	Eyw::datatype_ptr _pOutOutput;

	std::vector<Eyw::datatype_ptr> _vector;

};
